//  XML Handler to capture Areas

import org.ccil.cowan.sax.*;
import org.xml.sax.*;
import org.xml.sax.helpers.*;
import java.io.IOException;
import java.net.*;
import java.util.*;

public class EventHandler extends HandlerBase{
	private Vector areas;			// list of areas
	private String thisDoc;			//  URL of current document
	private String image;			//  Referenced Image
	private String caption;			//  Caption text
	private String currentTagName;	//  Temporary Holding Variables
	private String idTemp, srcTemp;
	private String shapeTemp, coordsTemp, captionTemp;
	private String titleTemp;

	//  this time we need the url of the originating document
	//  to create multi-directional links
	public EventHandler (URL xmlURL, LinkSet tempLinks) throws IllegalAccessException, InstantiationException,
             ClassNotFoundException {
		String parserClass="com.microstar.xml.SAXDriver";
		Parser parser;
		XLinkFilter parserFilter;
		thisDoc=xmlURL.toString();
		areas=new Vector();
		
		parser=ParserFactory.makeParser(parserClass);
		parserFilter=new XLinkFilter(parser);
		parserFilter.setDocumentHandler(this);
		parserFilter.setLinkSet(tempLinks);
		
		try {
		  parserFilter.parse(xmlURL.toString());
		} catch (Exception e) {
		  e.printStackTrace();
		}



}



	public String getImage() { return image; }
	public String getCaption(){ return caption; }
	public Vector getAreas() { return areas; }

	//  Override HandlerBase methods
	public void startElement (String Name,AttributeList atts) {
	//convert Attributes to temp variables
	currentTagName=Name;
   	 int length = atts.getLength();
   	 for (int i = 0; i < length; i++) {
    	  String aName = atts.getName(i);
    	  String aValue = atts.getValue(i);
		if (aName.equals("src")) srcTemp=aValue;
		else if (aName.equals("id")) idTemp=aValue;
		else if (aName.equals("shape")) shapeTemp=aValue;
		else if (aName.equals("coords")) coordsTemp=aValue;
	}
	}


	public void endElement(String Name){
		//  working variables
		int left, right, top, bottom;

		//  image element and caption are simple
		if (Name.equals("image")) image=srcTemp;
		else if (Name.equals("caption")) caption=captionTemp;
		
		//  area element combines link info to create genuinely
		//  extended links, not just two-way links

		else if (Name.equals("area")){
			StringTokenizer tokens=new StringTokenizer(coordsTemp, ",");
			left=Integer.parseInt(tokens.nextToken());
			top=Integer.parseInt(tokens.nextToken());
			right=Integer.parseInt(tokens.nextToken());
			bottom=Integer.parseInt(tokens.nextToken());
			Area currentArea=new Area(idTemp, shapeTemp, left,top,right,bottom);
			areas.addElement(currentArea);
			
		}

		

		
	}


	//  charData used only for caption
	public void characters (char ch[], int start, int length) {
    		String text = new String (ch, start, length);
		if (currentTagName.equals("caption")) captionTemp=text;
	}
	
}